<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-11-13 16:37:02
 * @LastEditors: 无尘
 * @LastEditTime: 2019-11-27 11:14:01
 -->
<!--
<finished-active></finished-active>

import finishedActive from '@/components/active/finished-active.vue';
-->

<template>
  <div class="finished-active border-box">
    <ul>
      <template v-for="(item, index) in finishedData">
        <li
          :class="['border-box', selectItem == item.activityId && index != 0 ? 'li-border' : '']"
          :key="index + 'data'"
        >
          <div
            class="finished-active-title flex flex-space-between border-box"
            @click.stop="selectLi(item)"
          >
            <div class="active-title-left">
              <div class="active-title-name font-18 color-303133">{{ item.activityName }}</div>
              <div class="active-title-date font-14 color-909399 m-t-7">{{ item.startDate | formatTimeYmdHms }} - {{ item.endDate | formatTimeYmdHms }}</div>
            </div>
            <div class="active-title-right">
              <el-button
                type="primary"
                plain
                @click="toEdit(index, item)"
              >活动配置</el-button>
              <!-- <el-button
                type="primary"
                plain
                @click="handleCopy(index, item)"
              >复制路径</el-button> -->
              <el-button
                type="primary"
                plain
                @click="toDataList(index, item)"
              >数据明细</el-button>
            </div>
          </div>
          <div
            v-if="selectItem == item.activityId"
            class="finished-active-body"
          >
            <out-date-active
              :barChartData="barChartData"
              :funnelData="funnelData"
            ></out-date-active>
          </div>
        </li>
      </template>
    </ul>
    <div
      class="pagination text-right m-t-14"
      v-if="total"
    >
      <el-pagination
        small
        :page-size="pageSize"
        :current-page="currentPage"
        layout="prev, pager, next"
        :total="total"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
      > </el-pagination>
    </div>
  </div>
</template>
<script>
import outDateActive from '@/components/active/out-date-active.vue';
import Clipboard from 'clipboard';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
import { getRequest } from '@/api/api';
export default {
  name: 'finished-active',
  components: {
    outDateActive
  },
  data() {
    return {
      funnelData: [],
      barChartData: {
        columns: ['日期', '访问用户', '下单用户'],
        rows: [{ 日期: '1/1', 访问用户: 1393, 下单用户: 1093,  }, { 日期: '1/2', 访问用户: 3530, 下单用户: 3230 }, { 日期: '1/3', 访问用户: 2923, 下单用户: 2623 }, { 日期: '1/4', 访问用户: 1723, 下单用户: 1423 }, { 日期: '1/5', 访问用户: 3192, 下单用户: 3192}, { 日期: '1/6', 访问用户: 3593, 下单用户: 3293 }]
      },
      selectItem: '',
      finishedData: [
        {
          activityId: 1,
          activityName: '1',
          startDate: 1574300553953,
          endDate: 1574300553953
        }
      ],
      // 分页
      pageSize: 20,
      currentPage: 1,
      total: 1
    };
  },
  methods: {
    /**
     * 选择 li
     */
    selectLi(item) {
      const that = this;
      that.selectItem = item.activityId;
      that.getActivityData(item.activityId);
    },
    /**
     * 获取单个活动数据信息
     * /sharing-core-web/get-activity-data-summary
     */
    getActivityData(activityId) {
      const that = this;
      let para = {
        activityId: activityId
      };
      getRequest('/sharing-core-web/get-activity-data-summary', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            that.funnelData = resData.result;
            that.barChartData = resData.result.trend;
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    /**
     * 活动配置
     */
    toEdit(index, row) {
      const that = this;
      that.$router.push(`/createActive?activityId=${row.activityId}&editFlag=show`)
    },
    /**
     * 数据明细
     */
    toDataList(index, row) {
      const that = this;
      that.$router.push(`/dataDetail?activityId=${row.activityId}`)
    },
    /**
     * 复制路径
     */
    handleCopy(index, row) {
      let clipboard = new Clipboard('.copy-tag', {
        text: function() {
          return `${window.location.origin}/?articleId=${row.articleId}`;
        }
      });
      clipboard.on('success', e => {
        showMsg.showmsg('复制成功!', 'success');
        // 释放内存
        clipboard.destroy();
      });
      clipboard.on('error', e => {
        // 不支持复制
        showMsg.showmsg('该浏览器不支持自动复制!', 'warning');
        // 释放内存
        clipboard.destroy();
      });
    },
    /**
     *  分页
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.getData();
    },
    handleCurrentChange(val) {
      this.currentPage = val;
      this.getData();
    },
    /**
     * 获取列表数据
     */
    getTableList() {
      const that = this;
      let para = {
        pageNum: that.currentPage,
        pageSize: that.pageSize
      };
      getRequest('/sharing-core-web/page-activity', para)
        .then(res => {
          let resData = res.data;
          const nowDate = new Date().getTime();
          if (resData.errorCode == 1) {
            let arr = [];
            if (resData.result.result && resData.result.result.length) {
              resData.result.result.forEach(ele => {
                if (ele.endDate < nowDate) {
                  arr.push(ele);
                }
              });
            }
            that.finishedData = arr || [];
            that.total = resData.result.totalCount;
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },
  mounted() {
    const that = this;
    that.getTableList();
  }
};
</script>
<style lang="less" scoped>
.m-t-7 {
  margin-top: 7px;
}
.finished-active {
  width: 100%;
  padding: 0 20px 48px 20px;
  background: #fff;
  li {
    // height: 90px;
    padding: 0 20px;
    cursor: pointer;
    &.li-border {
      padding: 0 20px;
      box-shadow: 0px 0px 8px 3px rgba(154, 170, 201, 0.11);
      border-radius: 4px;
      border: 1px solid rgba(220, 223, 230, 1);
      margin-top: -1px;
    }
    .finished-active-title {
      padding: 27px 0 20px 0;
      border-bottom: 1px solid #dcdfe6;
    }
    .finished-active-body {
      padding: 20px 0;
    }
  }
}
</style>
